"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _factory = require("./factory");

var _factory2 = _interopRequireDefault(_factory);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Variate = function () {
  function Variate() {
    (0, _classCallCheck3.default)(this, Variate);
  }

  (0, _createClass3.default)(Variate, [{
    key: "init",
    value: function init(_ref) {
      var cookie = _ref.cookie;

      this.cookie(cookie);
    }
  }, {
    key: "pattern",
    value: function pattern() {
      var server = function server() {
        return typeof document == "undefined";
      };
      return {
        callCallback: function callCallback(_ref2) {
          var cached = _ref2.cached;
          return !server() && !cached;
        },
        callRemoteCallback: function callRemoteCallback(_ref3) {
          var cached = _ref3.cached;
          return !server() && !cached;
        },
        selectFirstVariant: function selectFirstVariant() {
          return server();
        },
        selectRandomVariant: function selectRandomVariant() {
          return !server();
        }
      };
    }
  }, {
    key: "callCallback",
    value: function callCallback(_ref4) {
      var args = _ref4.args;
      var callback = _ref4.state.callback;

      if (callback) {
        callback(args);
      }
      return {};
    }
  }, {
    key: "callRemoteCallback",
    value: function callRemoteCallback(_ref5) {
      var args = _ref5.args;
      var remoteCallback = _ref5.state.remoteCallback;

      if (remoteCallback) {
        remoteCallback(args);
      }
      return {};
    }
  }, {
    key: "convert",
    value: function convert() {
      return [this.getTest, this.selectFirstVariant, this.selectRandomVariant, this.cookie().get, this.cookie().set, this.setConverted, this.cookie().get, this.callCallback, this.cookie().set, this.returnVariant];
    }
  }, {
    key: "getTest",
    value: function getTest(_ref6) {
      var name = _ref6.name;
      var tests = _ref6.state.tests;

      return { test: tests[name] };
    }
  }, {
    key: "remoteConvert",
    value: function remoteConvert() {
      return [this.cookie().get, this.setConverted, this.cookie().get, this.callRemoteCallback, this.cookie().set, this.remote().postConversion, this.returnVariant];
    }
  }, {
    key: "remoteTest",
    value: function remoteTest() {
      return [this.remote().getVariant, this.cookie().get, this.callRemoteCallback, this.cookie().set, this.returnVariant];
    }
  }, {
    key: "returnVariant",
    value: function returnVariant(_ref7) {
      var variant = _ref7.variant;

      return variant;
    }
  }, {
    key: "selectFirstVariant",
    value: function selectFirstVariant(_ref8) {
      var test = _ref8.test;

      return { variant: test[0] };
    }
  }, {
    key: "selectRandomVariant",
    value: function selectRandomVariant(_ref9) {
      var test = _ref9.test;

      var index = Math.random() * test.length;
      index = Math.floor(index);
      return { variant: test[index] };
    }
  }, {
    key: "setConverted",
    value: function setConverted() {
      return { converted: true };
    }
  }, {
    key: "test",
    value: function test() {
      return [this.getTest, this.selectFirstVariant, this.selectRandomVariant, this.cookie().get, this.callCallback, this.cookie().set, this.returnVariant];
    }
  }, {
    key: "updated",
    value: function updated() {
      this.cookie(this.state());
      this.remote(this.state());
    }
  }]);
  return Variate;
}();

exports.default = (0, _factory2.default)(Variate);
//# sourceMappingURL=variate.js.map