"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _factory = require("./factory");

var _factory2 = _interopRequireDefault(_factory);

var _jsCookie = require("js-cookie");

var _jsCookie2 = _interopRequireDefault(_jsCookie);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Cookie = function () {
  function Cookie() {
    (0, _classCallCheck3.default)(this, Cookie);
  }

  (0, _createClass3.default)(Cookie, [{
    key: "init",
    value: function init() {
      this.cache = _jsCookie2.default.getJSON("variate") || {};
    }
  }, {
    key: "pattern",
    value: function pattern() {
      return {
        convertedKey: { converted: true },
        getCache: { cached: true },
        setCookie: { cached: function cached(c) {
            return !c;
          } }
      };
    }
  }, {
    key: "cacheStatus",
    value: function cacheStatus(_ref) {
      var key = _ref.key;

      return { cached: !!this.cache[key] };
    }
  }, {
    key: "convertedKey",
    value: function convertedKey(_ref2) {
      var name = _ref2.name;

      return { key: "c:" + name };
    }
  }, {
    key: "getCache",
    value: function getCache(_ref3) {
      var name = _ref3.name;

      return { variant: this.cache[name] };
    }
  }, {
    key: "key",
    value: function key(_ref4) {
      var name = _ref4.name;

      return { key: name };
    }
  }, {
    key: "get",
    value: function get() {
      return [this.key, this.convertedKey, this.cacheStatus, this.getCache];
    }
  }, {
    key: "set",
    value: function set() {
      return [this.key, this.convertedKey, this.cacheStatus, this.setCache, this.setCookie];
    }
  }, {
    key: "setCache",
    value: function setCache(_ref5) {
      var converted = _ref5.converted;
      var key = _ref5.key;
      var variant = _ref5.variant;

      this.cache[key] = converted ? 1 : variant;
      return {};
    }
  }, {
    key: "setCookie",
    value: function setCookie(_ref6) {
      var cookie = _ref6.state.cookie;

      _jsCookie2.default.set("variate", this.cache, cookie);
      return {};
    }
  }]);
  return Cookie;
}();

exports.default = (0, _factory2.default)(Cookie);
//# sourceMappingURL=cookie.js.map